data Empty {}
data Unit { unit }
data Bool { true; false }

fun If : (b : Bool) -> ++(A, B : Set) -> Set
{ If true  A B = A
; If false A B = B
}

let Either ++(A, B : Set) = (b : Bool) & If b B A
pattern left  a = (false, a)
pattern right b = (true, b)

{- Nisse, 2012-01-31
I would like to be able to define Mu and Inf in such a way that I can
define stream processors "exactly" as in Agda:

  let SP (A : Set) (B : Set) : Set =
    Mu (\ X -> Either (A -> X) (B & Inf X))

This would hopefully give a clean and "simple" semantics of Agda's ∞.

However, I'm not sure if this is possible. To start with I don't quite
understand why the following definition is not accepted:
-}

  let B2 -(i : Size) -(f : Size) = -(i' <= i) -> +(f' <= f) -> Set

fail
  cofun Mu' : -(i : Size) -> +(f : Size) ->
              (++ B2 i f -> Set) ->
              |f| -> Set
  { Mu' i f F = F (\ i' f' -> [f'' < f'] & Mu' i' f'' F)
  }

{- Andreas: derivation

  G = -i:Size, +f:Size, F : B2 i f,  
      Mu' : -(i0 : Size) -> +(f0 < f) -> (++ B2 i0 f0 -> Set) -> Set  

  check G |- (\ i' f' -> [f'' < f'] & Mu' i' f'' F) : B2 i f

  G' = G, -i'<=i, +f'<=f
  check G' |- [f'' < f'] & Mu' i' f'' F : Set

  G'' = G', f'' < f'
  check Mu' i' f'' F : Set
  infer Mu' i' f'' : (++ B2 i' f'' -> Set) -> Set
  check F : ++ B2 i' f'' -> Set
  infer F : ++ B2 i  f   -> Set
  check  ++ B2 i f -> Set <=  ++ B2 i' f'' -> Set
  check B2 i' f'' <= B2 i f
  check i <= i'  FAILS
  check f <= f'' FAILS

You are trying to apply

  Mu i' f'' : (++ B2 i' f'' -> Set) -> |f''| < |f| -> Set

to
  
  F : ++ B2 i f -> Set

This requires

-}

{-
If this definition were accepted, then I could define SP as follows:

  let Mu : (++(-Size -> +Size -> Set) -> Set) -> Set =
    Mu' # #

  let Inf' -(i : Size) ++(F : -(i' < i) -> +Size -> Set) : Set
    = [i' < i] -> F i' #

  let Inf ++(F : -(i < #) -> +Size -> Set) : Set
    = Inf' # F

  let SP (A, B : Set) : Set =
    Mu (\ X -> Either (A -> X # #) (B & Inf X))

However, perhaps we need to add some indices to make this definition
usable. I haven't tried to define the semantics of a stream processor
yet.
-}
