-- 2012-02-05  Check whether we can define dependent case in MiniAgda

let Map (F : Set -> Set) 
  = [A, B : Set] -> (A -> B) -> F A -> F B

cofun Nu : (F : Set -> Set) -(i : Size) -> Set
{ Nu F i = [j < i] -> F (Nu F j)
}

-- destructor

let out [F : Set -> Set] [i : Size] (r :  Nu F $i) : F (Nu F i)
  = r i
-- fails to typecheck (would succeed if i<#)

-- constructor (needs monotonicity of F)

check
fun inn : [F : +Set -> Set] [i : Size] -> F (Nu F i) -> Nu F $i
{ inn F i t j = t
} 

let inn [F : +Set -> Set] [i : Size] (t : F (Nu F i)) : Nu F $i
  = \ j -> t

-- coiteration

fun coit : [F : +Set -> Set] (map : Map F) 
  [S : Set] (step : S -> F S) 
  [i : Size] -> |i| -> (start : S) -> Nu F i
{ coit F map S step i start 
    = \ j -> map S (Nu F j) (coit F map S step j) (step start) 
}

{- not needed (eta is built-in)
-- eta 

let eta [F : +Set -> Set] [i : Size] (r : Nu F $i) : Nu F $i
  = \ j -> r j

fun caseNu : [F : +Set -> Set] 
  [P : (i : Size) -> Nu F i -> Set] 
  (f : [i : Size] -> (t : F (Nu F i)) -> P $i (inn F i t))
  [i : Size] (x : Nu F $i) -> P $i (eta F i x)
{ caseNu F P f i x = f i (x i)
}
-}

-- case

let caseNu
  [F : +Set -> Set] 
  [P : (i : Size) -> Nu F i -> Set] 
  (f : [i : Size] -> (t : F (Nu F i)) -> P $i (inn F i t))
  [i : Size] 
  (x : Nu F $i) : P $i x
                = f i (x i)

